OpenShot Audio Library | OpenShotAudio: juce::AsyncUpdater Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::AsyncUpdater Class Referenceabstract

`#include <juce_AsyncUpdater.h>`

Inheritance diagram for juce::AsyncUpdater:

## Public Member Functions
| AsyncUpdater ()
virtual | ~AsyncUpdater ()
void | triggerAsyncUpdate ()
void | cancelPendingUpdate () noexcept
void | handleUpdateNowIfNeeded ()
bool | isUpdatePending () const noexcept
virtual void | handleAsyncUpdate ()=0

## Detailed Description

Has a callback method that is triggered asynchronously.

This object allows an asynchronous callback function to be triggered, for tasks such as coalescing multiple updates into a single callback later on.

Basically, one or more calls to the triggerAsyncUpdate() will result in the message thread calling handleAsyncUpdate() as soon as it can.

Definition at line 38 of file juce_AsyncUpdater.h.

## Constructor & Destructor Documentation

## ◆ AsyncUpdater()

juce::AsyncUpdater::AsyncUpdater | ( |  | ) |

Creates an AsyncUpdater object.

Definition at line 44 of file juce_AsyncUpdater.cpp.

## ◆ ~AsyncUpdater()

juce::AsyncUpdater::~AsyncUpdater | ( |  | ) |
| virtual

Destructor. If there are any pending callbacks when the object is deleted, these are lost.

Definition at line 49 of file juce_AsyncUpdater.cpp.

## Member Function Documentation

## ◆ cancelPendingUpdate()

void juce::AsyncUpdater::cancelPendingUpdate | ( |  | ) |
| noexcept

This will stop any pending updates from happening.

If called after triggerAsyncUpdate() and before the handleAsyncUpdate() callback happens, this will cancel the handleAsyncUpdate() callback.

Note that this method simply cancels the next callback - if a callback is already in progress on a different thread, this won't block until the callback finishes, so there's no guarantee that the callback isn't still running when the method returns.

Definition at line 74 of file juce_AsyncUpdater.cpp.

Referenced by juce::ChangeBroadcaster::sendSynchronousChangeMessage(), and triggerAsyncUpdate().

## ◆ handleAsyncUpdate()

virtual void juce::AsyncUpdater::handleAsyncUpdate | ( |  | ) |
| pure virtual

Called back to do whatever your class needs to do.

This method is called by the message thread at the next convenient time after the triggerAsyncUpdate() method has been called.

Referenced by handleUpdateNowIfNeeded().

## ◆ handleUpdateNowIfNeeded()

void juce::AsyncUpdater::handleUpdateNowIfNeeded | ( |  | ) |

If an update has been triggered and is pending, this will invoke it synchronously.

Use this as a kind of "flush" operation - if an update is pending, the handleAsyncUpdate() method will be called immediately; if no update is pending, then nothing will be done.

Because this may invoke the callback, this method must only be called on the main event thread.

Definition at line 79 of file juce_AsyncUpdater.cpp.

Referenced by juce::ChangeBroadcaster::dispatchPendingMessages().

## ◆ isUpdatePending()

bool juce::AsyncUpdater::isUpdatePending | ( |  | ) | const
| noexcept

Returns true if there's an update callback in the pipeline.

Definition at line 88 of file juce_AsyncUpdater.cpp.

Referenced by ~AsyncUpdater().

## ◆ triggerAsyncUpdate()

void juce::AsyncUpdater::triggerAsyncUpdate | ( |  | ) |

Causes the callback to be triggered at a later time.

This method returns immediately, after which a callback to the handleAsyncUpdate() method will be made by the message thread as soon as possible.

If an update callback is already pending but hasn't happened yet, calling this method will have no effect.

It's thread-safe to call this method from any thread, BUT beware of calling it from a real-time (e.g. audio) thread, because it involves posting a message to the system queue, which means it may block (and in general will do on most OSes).

Definition at line 62 of file juce_AsyncUpdater.cpp.

Referenced by juce::ChangeBroadcaster::sendChangeMessage().

The documentation for this class was generated from the following files:

- juce_AsyncUpdater.h
- juce_AsyncUpdater.cpp